#include <stdlib.h>
#include "screen.h"
#include "poly.h"

#define  swap(a,b)  {int tmp_var;tmp_var=(a);(a)=(b);(b)=tmp_var;}
#define  isgn(x)    (((x)>0)-((x)<0))
#define  iabs(x)    ((x)>0 ? (x):-(x))

void put_line( int x0, int y0, int x1, int y1, struct VRAM_PIX *pix )
{
struct VRAM_PIX *vp=(struct VRAM_PIX*)VRAM_TOP ;
int dx,dy ;
int x, y ; 
int i, j ;

 // printf("%d,%d - %d,%d\n",x0,y0,x1,y1) ;
 if( iabs(x1-x0)>iabs(y1-y0) ){
   if( x0>x1 ){
     swap(x0,x1) ;
     swap(y0,y1) ;
   }
   dx=(iabs(x1-x0)+1)*isgn(x1-x0)*256;
   dy=(iabs(y1-y0)+1)*isgn(y1-y0)*256 ;
   for( i=x0 ; i<x1 ; i++ ){
     if( i<0 || i>=SCREEN_WIDTH  ) continue ;
     y=dy*(i-x0)/dx + y0 ;
     if( y<0 || y>=SCREEN_HEIGHT ) continue ;
     vp[y*VRAM_WIDTH+i] = *pix ;
   }
 }else{
   if( y0>y1 ){
     swap(x0,x1) ;
     swap(y0,y1) ;
   }
   dx=(iabs(x1-x0)+1)*isgn(x1-x0)*256;
   dy=(iabs(y1-y0)+1)*isgn(y1-y0)*256 ;
   for( i=y0 ; i<y1 ; i++ ){
     if( i<0 || i>=SCREEN_HEIGHT ) continue ;
     x=dx*(i-y0)/dy + x0 ;
     if( x<0 || x>=SCREEN_WIDTH  ) continue ;
     vp[i*VRAM_WIDTH+x] = *pix ;
   }
 }
}
